package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk;

import androidx.annotation.NonNull;

import com.alibaba.fastjson.JSON;
import com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk.plugin.FPOfBase;
import com.aliyun.roompaas.base.exposable.Callback;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

/**
 * Created by KyleCe on 2022/3/30
 */
public class CallbackAdapter<T> implements Callback<T> {
    private final MethodChannel.Result result;
    private final MethodCall call;
    private final String api;
    private final boolean resultAssembledInJson;

    public CallbackAdapter(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {
        this(call, result, false);
    }

    public CallbackAdapter(@NonNull MethodCall call, @NonNull MethodChannel.Result result, boolean resultAssembledInJson) {
        this.call = call;
        this.result = result;
        this.api = call.method;
        this.resultAssembledInJson = resultAssembledInJson;
    }

    @Override
    public void onSuccess(T t) {
        FPOfBase.takeSuccess(result, !resultAssembledInJson ? t : JSON.toJSONString(t));
    }

    @Override
    public void onError(String s) {
        FPOfBase.takeGeneralErr(result, api + " onError: " + s);
    }
}
