package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk;

import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.lifecycle.Lifecycle;
import androidx.lifecycle.LifecycleObserver;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodChannel;

/**
 * Created by KyleCe on 2022/3/30
 */
public class FUtils {

    public static void onAttachedToEngine(@Nullable FlutterPlugin.FlutterPluginBinding binding, @Nullable FlutterPlugin... plugins) {
        if (plugins == null || plugins.length == 0 || binding == null) {
            return;
        }

        for (FlutterPlugin plugin : plugins) {
            if (plugin != null) {
                plugin.onAttachedToEngine(binding);
            }
        }
    }

    public static void onDetachedFromEngine(@Nullable FlutterPlugin.FlutterPluginBinding binding, @Nullable FlutterPlugin... plugins) {
        if (plugins == null || plugins.length == 0 || binding == null) {
            return;
        }

        for (FlutterPlugin plugin : plugins) {
            if (plugin != null) {
                plugin.onDetachedFromEngine(binding);
            }
        }
    }

    public static void clear(@Nullable MethodChannel mc) {
        applyHandler(mc, null);
    }

    public static void applyHandler(@Nullable MethodChannel mc, @Nullable MethodChannel.MethodCallHandler handler) {
        if (mc != null) {
            mc.setMethodCallHandler(handler);
        }
    }

    public static void addChildMatchParentSafely(@Nullable ViewGroup vg, @Nullable View child, @Nullable ViewGroup.LayoutParams lp) {
        if (vg != null && child != null) {
            if (child.getParent() instanceof ViewGroup) {
                ViewGroup originParent = (ViewGroup) child.getParent();
                if (originParent.equals(vg)) {
                    return;
                }

                removeChildFromParent(originParent, child);
            }

            vg.addView(child, lp != null ? lp : new ViewGroup.LayoutParams(-1, -1));
        }
    }

    public static void removeChildFromParent(@NonNull ViewGroup vg, @NonNull View self) {
        self.clearAnimation();
        vg.removeView(self);
    }

    public static void removeLifecycleObserver(@Nullable Lifecycle cycle, @Nullable LifecycleObserver obs) {
        if (cycle != null && obs != null) {
            cycle.removeObserver(obs);
        }
    }
}
