package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk;

import androidx.annotation.StringDef;

import com.aliyun.roompaas.player.exposable.CanvasScale;

/**
 * @author puke
 * @version 2022/3/4
 */
public class ShowModeUtil {

    public static final String MODE_FILL = "fill";
    public static final String MODE_ASPECT_FILL = "aspect_fill";
    public static final String MODE_ASPECT_FIT = "aspect_fit";

    @StringDef({
            MODE_FILL,
            MODE_ASPECT_FILL,
            MODE_ASPECT_FIT,
    })
    public @interface ShowMode {
    }

    public static int getShowMode(@ShowMode String mode) {
        switch (mode) {
            case MODE_FILL:
                return CanvasScale.Mode.SCALE_FILL;
            case MODE_ASPECT_FIT:
                return CanvasScale.Mode.ASPECT_FIT;
            case MODE_ASPECT_FILL:
            default:
                return CanvasScale.Mode.ASPECT_FILL;
        }
    }
}
