package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk.beauty;

import android.app.Dialog;
import android.content.Context;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk.R;
import com.aliyun.roompaas.base.IDestroyable;
import com.aliyun.roompaas.beauty_base.BeautyStrategy;
import com.aliyun.roompaas.beauty_base.IBeautyOptUpdate;
import com.aliyun.roompaas.live.exposable.AliLiveBeautyOptions;
import com.aliyun.roompaas.live.exposable.LivePusherService;
import com.aliyun.roompaas.live.exposable.LiveService;
import com.aliyun.roompaas.uibase.util.DialogUtil;

/**
 * 美颜视图
 *
 * @author puke
 * @version 2021/7/29
 */
public class LiveBeautyDelegate implements IBeautyOptUpdate, IDestroyable {

    @Nullable
    private Dialog dialog;
    @Nullable
    private Context context;
    @Nullable
    private LiveService liveService;

    public LiveBeautyDelegate(@NonNull Context context, @Nullable LiveService liveService) {
        this.context = context;
        this.liveService = liveService;
    }

    public void openPanel() {
        ofDialog().show();
    }

    public void closePanel(){
        if (dialog != null && dialog.isShowing()) {
            dialog.dismiss();
        }
    }

    private Dialog ofDialog() {
        if (dialog == null) {
            dialog = DialogUtil.createDialogOfBottom(context, ViewGroup.LayoutParams.WRAP_CONTENT,
                    R.layout.ilr_view_float_live_queen_beauty, true);
            BeautyStrategy.INSTANCE.setUp((ViewGroup) dialog.findViewById(R.id.beautyContainer), this);
        }

        return dialog;
    }

    @Override
    public void onUpdateBeautyOpt(AliLiveBeautyOptions beautyOptions) {
        LivePusherService lps = getPusherService();
        if (lps != null) {
            lps.updateBeautyOptions(beautyOptions);
        }
    }

    @Nullable
    public LivePusherService getPusherService() {
        return liveService != null ? liveService.getPusherService() : null;
    }

    @Override
    public void destroy() {
        context = null;
        liveService = null;
    }
}
