#import "IMPEvent.h"
#import "IMPRoomChannelManager.h"
#import "AIMPSConf.h"

@import AliInteractiveRoomBundle;

@implementation IMPEvent

+ (IMPEvent *)ins {
    static IMPEvent *sharedInstance = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        sharedInstance = [[IMPEvent alloc] init];
    });
    return sharedInstance;
}

+ (void)fireEvent:(NSString *)event {
    [self fireEvent:event params:nil];
}

+ (void)fireEvent:(NSString *)event params:(NSDictionary *_Nullable)params {
    NSLog([NSString stringWithFormat:@"AAA iOS fireEvent--event:%@,param:%@, emitter: %@", event, params, [self ins].emitter]);
    if ([self ins].emitter) {
        NSMutableDictionary *contentDictionary = [[NSMutableDictionary alloc] init];
        [contentDictionary setValue:event forKey:@"event"];
        [contentDictionary setValue:params forKey:@"params"];
        NSError *error;
        NSData *jsonData = [NSJSONSerialization dataWithJSONObject:contentDictionary
                                                           options:0
                                                             error:&error];
        NSString *jsonString;
        if (jsonData) {
            jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
        } else {
            NSLog(@"Got an error: %@", error);
            jsonString = @"";
        }
        NSLog([NSString stringWithFormat:@"AAA iOS fireEvent: %@", jsonString]);
        dispatch_async(dispatch_get_main_queue(), ^{
            [self ins].emitter(jsonString);
        });
    }
}

- (FlutterError *_Nullable)onListenWithArguments:(id _Nullable)arguments
                                       eventSink:(FlutterEventSink)events {
    NSLog([NSString stringWithFormat:@"AAA iOS set emitter: %@", events]);
    _emitter = events;
    return nil;
}

- (FlutterError *_Nullable)onCancelWithArguments:(id _Nullable)arguments {
    return nil;
}

@end
