import 'dart:async';

import 'package:flutter/services.dart';
import 'utils.dart';

class IMPSdkLivePlayer {
  static const channelTag = 'alicloud_impinteraction_sdk_live_player';
  static const MethodChannel _mc = MethodChannel(channelTag);

  /// returns the result of api in format of [Result]
  static Future<M> start([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('start', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> pause([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('pause', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> resume([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('resume', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> stop([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('stop', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> refresh([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('refresh', p));
  }
}
